% Copyright 2008 INRIA, F. Fages & J. Martin
% License GPL
%
% file r2cp.pl
%
:- ensure_loaded(library(system)).
:- ensure_loaded([err]).
:- ensure_loaded([compiler]).

				%r2cp(['rules2cp/examples/nqueens/queens.rcp']).
				%r2cpchoco(['rules2cp/examples/nqueens/queens.rcp']).

				%r2cp(['../../examples/scheduling/scheduling.rcp']).
				%r2cp(['../../examples/scheduling/bridge.rcp']).

				%r2cp(['rules2cp/examples/packing/packing.rcp']).
				%r2cpchoco(['rules2cp/examples/packing/packing.rcp']).

				%r2cp(['rules2cp/examples/packing/packing_polymorphism.rcp']).
				%r2cpchoco(['rules2cp/examples/packing/packing_polymorphism.rcp']).

				%r2cp(['rules2cp/examples/packing/psa.rcp']).
				%r2cpchoco(['rules2cp/examples/packing/psa.rcp']).

				%r2cp(['rules2cp/examples/packing/rpacking.rcp']).
				%r2cpgui(['rules2cp/examples/packing/psa_gui_pattern.rcp']).
				
:- dynamic rcp_path/1.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% clpfd - SICStus Prolog
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% command-line
%%%%%%%%%%%%%%%%%%%%%
r2cp :-
	prolog_flag(argv, Argv),
	on_exception(Error, r2cp(Argv), error_handler(Error)).

make_r2cp :-
	save_program(rcp, (r2cp, halt)).

% top-level
%%%%%%%%%%%%%%%%%%%%%
r2cp(Argv) :-
	r2cp_arguments(Argv, Files),
	compile(Files, clpfdsp).

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% clpfd - CHOCO Java
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% command-line
%%%%%%%%%%%%%%%%%%%%%
r2cpchoco :-
	prolog_flag(argv, Argv),
	on_exception(Error, r2cpchoco(Argv), error_handler(Error)).

make_r2cpchoco :-
	save_program(rcpchoco, (r2cpchoco, halt)).

% top-level
%%%%%%%%%%%%%%%%%%%%%
r2cpchoco(Argv) :-
	r2cp_arguments(Argv, Files),
	compile(Files, clpfdcj).

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% clpfd + clpgui - SICStus Prolog
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% command-line
%%%%%%%%%%%%%%%%%%%%%
r2cpgui :-
	prolog_flag(argv, Argv),
	r2cpgui(Argv).

make_r2cpgui :-
	save_program(rcpgui, (r2cpgui, halt)).

% top-level  
%%%%%%%%%%%%%%%%%%%%%
r2cpgui(Argv) :-
	r2cp_arguments(Argv, Files),
	compile(Files, clpfdguisp).

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% command-line arguments treatment
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
r2cp_arguments([], []).
r2cp_arguments(['-rcppath', Path | Argv], Files) :-
	!,
	assert(rcp_path(Path)),
	r2cp_arguments(Argv, Files).
r2cp_arguments([Arg | Argv], [Arg | Files]) :-
	r2cp_arguments(Argv, Files).
