package rules2cp.examples.packing;
import static rules2cp.interpreter.java.r2cp.*;
import rules2cp.interpreter.java.*;
import java.util.Vector;
import static choco.Choco.*;
import choco.cp.model.CPModel;
import choco.cp.solver.CPSolver;
import choco.cp.solver.search.integer.varselector.*;
import choco.cp.solver.search.integer.valselector.*;
import choco.cp.solver.search.integer.valiterator.*;
import choco.cp.solver.search.integer.branching.*;
import choco.cp.solver.constraints.integer.*;
import choco.cp.solver.constraints.global.geost.Constants;
import choco.cp.solver.constraints.global.geost.externalConstraints.ExternalConstraint;
import choco.cp.solver.constraints.global.geost.externalConstraints.NonOverlapping;
import choco.cp.solver.constraints.global.geost.geometricPrim.ShiftedBox;
import choco.kernel.model.Model;
import choco.kernel.model.constraints.*;
import choco.kernel.model.variables.*;
import choco.kernel.model.variables.integer.*;
import choco.kernel.model.variables.geost.GeostObject;
import choco.kernel.solver.Solver;
import choco.kernel.solver.branch.*;
import choco.kernel.solver.variables.integer.*;
import choco.kernel.model.variables.geost.*;

public class packing {

  public static void main(String[] args) {

    IntegerVariable o3_3 = rcp_var("from(o3, 3)");
    IntegerVariable o3 = rcp_var("from(o3, 1)");
    IntegerVariable o3_2 = rcp_var("from(o3, 2)");
    IntegerVariable o2_3 = rcp_var("from(o2, 3)");
    IntegerVariable o2 = rcp_var("from(o2, 1)");
    IntegerVariable o2_2 = rcp_var("from(o2, 2)");
    addConstraint(leq(0, o2));
    addConstraint(leq(plus(o2, 4), 5));
    addConstraint(leq(0, o2_2));
    addConstraint(leq(plus(o2_2, 5), 4));
    addConstraint(leq(0, o2_3));
    addConstraint(leq(plus(o2_3, 2), 4));
    addConstraint(leq(0, o3));
    addConstraint(leq(plus(o3, 5), 5));
    addConstraint(leq(0, o3_2));
    addConstraint(leq(plus(o3_2, 4), 4));
    addConstraint(leq(0, o3_3));
    addConstraint(leq(plus(o3_3, 2), 4));
    Vector<GeostObject> geost_obj = new Vector<GeostObject>();
    Vector<ShiftedBox> geost_sb = new Vector<ShiftedBox>();
    IntegerVariable start_4 = makeIntVar("start_4", 0, 0);
    IntegerVariable duration_4 = makeIntVar("duration_4", 1, 1);
    IntegerVariable end_4 = makeIntVar("end_4", 1, 1);
    IntegerVariable sid_4 = makeIntVar("sid_4", 3, 3);
    geost_obj.add(new GeostObject(3, 4, sid_4, new IntegerVariable[] {o2, o2_2, o2_3}, start_4, duration_4, end_4));
    IntegerVariable start_8 = makeIntVar("start_8", 0, 0);
    IntegerVariable duration_8 = makeIntVar("duration_8", 1, 1);
    IntegerVariable end_8 = makeIntVar("end_8", 1, 1);
    IntegerVariable sid_8 = makeIntVar("sid_8", 7, 7);
    geost_obj.add(new GeostObject(3, 8, sid_8, new IntegerVariable[] {o3, o3_2, o3_3}, start_8, duration_8, end_8));
    geost_sb.add(new ShiftedBox(3, new int[] {0, 0, 0}, new int[] {4, 5, 2}));
    geost_sb.add(new ShiftedBox(7, new int[] {0, 0, 0}, new int[] {5, 4, 2}));
    addConstraint(geost(3, geost_obj, geost_sb, non_overlapping(3, geost_obj)));
    Solver s = new CPSolver();
    s.read(rules2cp.interpreter.java.r2cp.model);
    CPSolver.setVerbosity(CPSolver.SEARCH);
    s.attachGoal(new AssignVar(new StaticVarOrder(s.getVar(new IntegerVariable[] {o3_3, o3, o3_2, o2_3, o2, o2_2})), new IncreasingDomain()));
    s.generateSearchStrategy();
    s.launch();
    CPSolver.flushLogs();
    System.out.println(s.pretty());
    
  }

}
