package rules2cp.interpreter.java;

import static choco.Choco.*;
import choco.cp.model.CPModel;
import choco.kernel.model.Model;
import choco.kernel.model.variables.*;
import choco.kernel.model.variables.integer.*;
import choco.kernel.model.constraints.*;

import choco.kernel.model.variables.geost.GeostObject;

import choco.cp.solver.constraints.global.geost.Constants;
import choco.cp.solver.constraints.global.geost.externalConstraints.ExternalConstraint;
import choco.cp.solver.constraints.global.geost.externalConstraints.NonOverlapping;
import choco.cp.solver.constraints.global.geost.geometricPrim.ShiftedBox;

import java.util.Hashtable;
import java.util.Enumeration;
import java.util.Vector;

public class r2cp {
    
    public static Model model = new CPModel();
    
    private static Hashtable<String, IntegerVariable> rcp_variables =
	new Hashtable<String, IntegerVariable>();
    
    public static IntegerVariable rcp_var(String name) {
	if(rcp_variables.containsKey(name)){
	    return rcp_variables.get(name);
	}
	else{
	    IntegerVariable var = makeIntVar(name, 0, 10000, "cp:bound");
	    rcp_variables.put(name, var);
	    return var;
	}
    }
    
    public static void domain(IntegerVariable variable, int lb, int ub) {
	variable.setLowB(lb);
	variable.setUppB(ub);
    }
    
    public static void domain(IntegerVariable[] variables, int lb, int ub) {
	for(int i = 0; i < variables.length; i++) {
	    domain(variables[i], lb, ub);
	}
    }
    
    public static void addVariable(Variable v) {
	model.addVariable(v);
    }
    
    public static void addConstraint(Constraint c) {
	model.addConstraint("cp:decomp", c);
    }
    
    public static Vector<ExternalConstraint>
	non_overlapping(int dim, Vector<GeostObject> geost_obj) {	
	Vector<ExternalConstraint> ectr = new Vector<ExternalConstraint>();   	            	
	int[] ectrDim = new int[dim];                                                      
	for (int d = 0; d < 3; d++) {
	    ectrDim[d] = d;
	}
	int n_objs = geost_obj.size();
	int[] objOfEctr = new int[n_objs];
	for (int n = 0; n < n_objs; n++) {
	    objOfEctr[n] = geost_obj.elementAt(n).getObjectId();
	}
	ectr.add(new NonOverlapping(Constants.NON_OVERLAPPING, ectrDim, objOfEctr));
	return ectr;
    }
}
